const sharp = require('sharp');
const fs = require('fs');
const path = require('path');

const ICON_SIZES = [16, 48, 128];
const SOURCE_ICON = path.join(__dirname, '../assets/icon.png');
const DIST_DIR = path.join(__dirname, '../dist/assets/icons');

// Create dist directory if it doesn't exist
if (!fs.existsSync(DIST_DIR)) {
  fs.mkdirSync(DIST_DIR, { recursive: true });
}

// Generate icons for each size
ICON_SIZES.forEach(size => {
  sharp(SOURCE_ICON)
    .resize(size, size)
    .toFile(path.join(DIST_DIR, `icon${size}.png`))
    .then(() => console.log(`Generated ${size}x${size} icon`))
    .catch(err => console.error(`Error generating ${size}x${size} icon:`, err));
});
